#ifndef RATIONAL_HPP // védelem a többszörös behelyezés ellen
#define RATIONAL_HPP

#include <iostream>
// nincs névtérhasználat megadva

// racionális szám típusa:
class Rational
{
private: // a mezõk és a segédmûveltek rejtettek
    int _numerator;
    int _denominator;

    void simplify(int& a, int& b) const; // egyszerûsítés, lehet konstans művelet

    // barát mûveletek:
    friend Rational operator+(int e, const Rational& r);
    friend Rational operator*(int e, const Rational& r);
    friend std::istream& operator>>(std::istream& s, Rational& r); // jelöljük a névteret
    friend std::ostream& operator<<(std::ostream &s, const Rational& r);
    friend Rational operator+=(Rational& r1, const Rational& r2);
    friend Rational operator+=(Rational& r, int e);
    friend int operator+=(int& e, const Rational& r);
    friend Rational operator*=(Rational& r1, const Rational& r2);
    friend Rational operator*=(Rational& r, int e);
    friend int operator*=(int& e, const Rational& r);

public: // a mûveletek publikusak
    // konstruktorok:
    Rational();
    Rational(int);
    Rational(int, int);

    // lekérdezõ és beállító mûveletek:
    void setNumerator(int value);
    void setDenominator(int value);
    int numerator() const; // a lekérdezések konstans műveletek
    int denominator() const;

    // operátor metódusok:
    Rational operator+(const Rational&) const; // az operátorok is konstans műveletek
    Rational operator+(int) const;
    Rational operator*(const Rational&) const;
    Rational operator*(int) const;
};

// további operátorok a típushoz:
Rational operator+(int e, const Rational& r);
Rational operator*(int e, const Rational& r);
std::istream& operator>>(std::istream& s, Rational &r); // jelöljük a névteret
std::ostream& operator<<(std::ostream &s, const Rational& r);
Rational operator+=(Rational& r1, const Rational& r2);
Rational operator+=(Rational& r, int e);
int operator+=(int& e, const Rational& r);
Rational operator*=(Rational& r1, const Rational& r2);
Rational operator*=(Rational& r, int e);
int operator*=(int& e, const Rational& r);


#endif // RATIONAL_HPP
